package com.engine.organization.mapper.staff;


import com.engine.organization.entity.staff.po.StaffPO;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.List;

/**
 * @Author dxfeng
 * @description:
 * @Date 2022/5/25
 * @Version V1.0
 **/
public interface StaffMapper {

    /**
     * 根据ID查询编制方案
     *
     * @param id
     * @return
     */
    StaffPO getStaffByID(@Param("id") long id);

    /**
     * 根据分部、部门、岗位查询编制
     *
     * @param companyId
     * @param departmentId
     * @param jobId
     * @return
     */
    List<StaffPO> getStaffByFilter(@Param("companyId") Long companyId, @Param("departmentId") Long departmentId, @Param("jobId") Long jobId);

    /**
     * 插入编制方案
     *
     * @param staffPO
     * @return
     */
    int insertIgnoreNull(StaffPO staffPO);

    /**
     * 修改，修改所有字段
     *
     * @param staffPO
     * @return
     */
    int updateStaff(StaffPO staffPO);


    /**
     * 批量删除
     *
     * @param ids
     */
    int deleteByIds(@Param("ids") Collection<Long> ids);

    /**
     * 查询所有被引用的ID
     *
     * @return
     */
    List<String> listUsedId();

    List<StaffPO> getStaffsByIds(@Param("ids") Collection<Long> ids);
}
